#include "testlib.h"

using namespace std;
typedef long long ll;

int n;
vector<ll> a;

pair<ll, int> check(InStream& in) {
    ll sum = in.readLong(0, ll(1e9) * n, "total");
    int k = in.readInt(0, n / 2, "pairs");
    vector<ll> used(n);
    ll realSum = 0;
    for (int i = 0; i < k; i++) {
        int x, y;
        x = in.readInt(1, n, "x");
        y = in.readInt(1, n, "x");
        x--;
        y--;
        if (x == y || used[x] || used[y]) {
            in.quitf(_wa, "incorrect pair");
        }
        used[x] = 1;
        if (used[y]) {
            in.quitf(_wa, "incorrect pair");
        }
        used[y] = 1;
        realSum += (a[x] + a[y]) / 100;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            realSum += a[i] / 100;
        }
    }
    if (realSum != sum) {
        in.quitf(_wa, "realSum != sum");
    }
    return {sum, -k};
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    a.resize(n);
    for (int i = 0; i < n; i++) {
        a[i] = inf.readInt();
    }

    pair<ll, int> paScore = check(ouf);
    pair<ll, int> jaScore = check(ans);

    if (paScore == jaScore) {
        quitf(_ok, "OK");
    } else if (paScore < jaScore) {
        quitf(_wa, "Participant's score is not optimal");
    } else {
        quitf(_fail, "Jury's score is not optimal sum: %lld > %lld, k: %d < %d", paScore.first, jaScore.first, paScore.second, jaScore.second);
    }
    return 0;
}
