#include "testlib.h"
#include <set>

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group() == "" ? -1 : atoi(validator.group().c_str());

    int n = inf.readInt(1, 200'000, "n");
    inf.readSpace();
    int m = inf.readInt(0, 200'000, "m");
    inf.readEoln();

    auto p = inf.readInts(n, 1, n, "p");
    ensuref(set<int>(p.begin(), p.end()).size() == n, "p is not a permutation");
    inf.readEoln();
    auto q = inf.readInts(n, 1, n, "p");
    ensuref(set<int>(q.begin(), q.end()).size() == n, "q is not a permutation");
    inf.readEoln();

    for (int i = 0; i < m; i++) {
        int a = inf.readInt(1, n, format("a_%d", i + 1));
        inf.readSpace();
        int b = inf.readInt(1, n, format("b_%d", i + 1));
        inf.readEoln();
        ensuref(a != b, "condition %d has a = b", i + 1);
    }

    inf.readEof();

    switch (group) {
        case 1:
            ensuref(n <= 3, "group 1, n = %d > 3", n);
            break;
        case 2:
            ensuref(n <= 18, "group 2, n = %d > 18", n);
            break;
        case 3:
            for (int i = 0; i < n; i++) {
                ensuref(p[i] == i + 1, "group 3, p_%d = %d", i + 1, p[i] + 1);
            }
            break;
        case 4:
            ensuref(m <= 1, "group 4, m = %d > 1", m);
            break;
        case 5:
            for (int i = 0; i < n; i++) {
                ensuref(q[p[i] - 1] == i + 1, "group 3, q_{p_%d} = %d", i + 1, q[p[i]] + 1);
            }
            break;
    }

}