#include <bits//stdc++.h>

#ifndef LOCAL
#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("inline")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-fwhole-program")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-fstrict-overflow")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-skip-blocks")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("-funsafe-loop-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
#endif

#define ll long long
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define ld long double


const int mod = 1e9 + 9;
const int inf = 1e9 + 1;


using namespace std;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    uniform_int_distribution<ll> range(l, r);
    return range(rng);
}


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
}


struct MinStack {
    struct Element {
        int ind, val, min1, min2;

        Element(int i, int v, Element pr) {
            ind = i;
            val = v;
            if (v <= pr.min1) {
                min2 = pr.min1;
                min1 = v;
            } else if (v <= pr.min2) {
                min1 = pr.min1;
                min2 = v;
            } else {
                min1 = pr.min1;
                min2 = pr.min2;
            }
        }

        Element(int i, int v) {
            ind = i;
            val = v;
            min1 = v;
            min2 = inf;
        }
    };

    vector<Element> st;

    bool isEmpty() {
        return st.empty();
    }

    void push(int ind, int priority) {
        if (st.empty()) {
            st.emplace_back(Element(ind, priority));
        } else {
            st.emplace_back(Element(ind, priority, st.back()));
        }
    }

    pair<int, int> pop() {
        if (st.empty()) {
            return {inf, inf};
        }
        pair<int, int> res = {st.back().ind, st.back().val};
        st.pop_back();
        return res;
    }

    int min1() {
        if (st.empty()) {
            return inf;
        }
        return st.back().min1;
    }

    int min2() {
        if (st.empty()) {
            return inf;
        }
        return st.back().min2;
    }

    pair<int, int> getPair() {
        return {min1(), min2()};
    }
};


pair<int, int> mergeMin(pair<int, int> m1, pair<int, int> m2) {
    if (m1.first <= m2.first) {
        return {m1.first, min(m1.second, m2.first)};
    } else {
        return {m2.first, min(m1.first, m2.second)};
    }
}


struct MinQueue {
    MinStack s1, s2;

    void push(int ind, int prior) {
        s2.push(ind, prior);
    }

    pair<int, int> pop() {
        if (s1.isEmpty()) {
            while (!s2.isEmpty()) {
                auto val = s2.pop();
                s1.push(val.first, val.second);
            }
        }
        return s1.pop();
    }

    bool isEmpty() {
        return s1.isEmpty() and s2.isEmpty();
    }

    int min1() {
        return min(s1.min1(), s2.min1());
    }

    int min2() {
        return mergeMin(s1.getPair(), s2.getPair()).second;
    }

    pair<int, int> getPair() {
        return mergeMin(s1.getPair(), s2.getPair());
    }
};


void solve() {
    int n, X;
    cin >> n >> X;
    MinQueue checked, unchecked;

    function<void()> scream = [&]() {
        auto twoMins = checked.getPair();
        while (!unchecked.isEmpty()) {
            auto cnt = unchecked.pop();
            if (cnt.second <= twoMins.second) {
                checked.push(cnt.first, cnt.second);
            }
            twoMins = mergeMin(twoMins, {cnt.second, inf});
        }
    };

    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        if (c == '+') {
            int ind, p;
            cin >> ind >> p;
            auto twoMins = mergeMin(checked.getPair(), unchecked.getPair());
            if (twoMins.second < p && (ll)(p - twoMins.first) * (p - twoMins.second) > X) {
                scream();
            } else {
                unchecked.push(ind, p);
            }
        } else {
            if (checked.isEmpty()) {
                cout << unchecked.pop().first << "\n";
            } else {
                cout << checked.pop().first << "\n";
            }
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}